﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NicoLib;

namespace NicoLibSample{
	class Program{
		static void Main(string[] args){
			Console.WriteLine("start");
			string debugNo = "-1";
													//"-1" = アラートテスト
													//"lv***" = コメントテスト

			if ( debugNo == "-1" ) {
				#region アラート
				
				Console.WriteLine("---アラートテスト---");

				NicoLib.Alert alert = new Alert();

				alert.getAlertEvent += new Alert.AlertHandler(
					delegate(AlertInfo info) {
						//最初から取れるのはこの3つ
						Console.WriteLine("broadcastID : " + info.broadcastID);
						Console.WriteLine("communityID : " + info.communityID);
						Console.WriteLine("userID : " + info.userID);

						//以下の情報は本来[api/getstreaminfo]にアクセスしないと取得できないが、
						//この値を使おうとした時にnullだったら自動で取りに行くようになっているため
						//使用しなければ無駄な処理は起こらないし、使いたい時は勝手にやってくれる。
						
						Console.WriteLine("title : " + info.title);
						Console.WriteLine("description : " + info.description);
						Console.WriteLine("requestID : " + info.requestID);
						Console.WriteLine("thumbnailURL : " + info.thumbnailURL);
						Console.WriteLine("communityName : " + info.communityName);
						
						Console.WriteLine("---");
					}
				);

				alert.Start();
				#endregion
			} else {
				#region コメント

				Console.WriteLine("---コメントテスト---");
				NicoLib.Live live = new Live("nakuyo@uguisu.jp","heiankyo");

				live.getCommentEvent += new Live.CommentHandler(
					delegate(Comment comment) {
						Console.WriteLine(comment.no + " - " + comment.text);
						/*
						Console.WriteLine("no : " + comment.no);
						Console.WriteLine("Comment : " + comment.text);
						Console.WriteLine("anonymity : " + comment.anonymity);
						Console.WriteLine("date : " + comment.date);
						Console.WriteLine("mail : " + comment.mail);
						Console.WriteLine("premium : " + comment.premium);
						Console.WriteLine("user_id : " + comment.user_id);
						Console.WriteLine("---");
						 */
					}
				);
				Console.Write("接続中... ");
				Console.WriteLine(live.Start(debugNo) ? "成功" : "失敗");
												//↑ここでさらっと接続
				//live.Start(放送番号,過去レス取得数)

				if ( false ) {
					live.SendComment(new Comment("コメント送信テスト" , "184"));
					Console.WriteLine("Comment send");
				}
				#endregion
			}
			
			Console.ReadLine();
		}
	}
}
